#include <stdio.h>

#include <fcntl.h>	/* open() */
#include <unistd.h>	/* close() */
#include <string.h>
#include <errno.h>

#include <sys/ioctl.h>
#include <linux/gpio.h>
#include <sys/time.h>

static int total_presses=0,total_releases=0;

static struct timeval last_time;

static long long timediff(struct timeval newtime, struct timeval oldtime) {

	long long bignew,bigold;

	bignew=(newtime.tv_sec*1000000)+newtime.tv_usec;
	bigold=(oldtime.tv_sec*1000000)+oldtime.tv_usec;

	return bignew-bigold;
}

void switch_pressed(void) {

	struct timeval press_time;

	total_presses++;

	gettimeofday(&press_time,NULL);

	printf("Switch pressed #%d after %lld us\n",
		total_presses,
		timediff(press_time,last_time));

	memcpy(&last_time,&press_time,sizeof(struct timeval));
}

void switch_released(void) {

	struct timeval release_time;

	total_releases++;

	gettimeofday(&release_time,NULL);

	printf("Switch released #%d after %lld us\n",
		total_releases,
		timediff(release_time,last_time));

	memcpy(&last_time,&release_time,sizeof(struct timeval));
}

